from resources.init import Init
from resources.init import InitEnv
from resources.operations import Operations


def main():
    options = Init.parse_args()
    env = InitEnv(options)

    available_workspaces = []
    for workspace in Operations.get_available_workspaces(env.base_url, env.session):
        available_workspaces.append({'slug': workspace['slug'], 'name': workspace['name']})

    workspace_selection = ""
    for position, workspace in enumerate(available_workspaces):
        workspace_selection += f"{workspace['name']} [{position}], "
    workspace_id = int(input(f"Please Select the number value of the workspace you wish to reset:\n{workspace_selection}\n"))
    if workspace_id >= len(workspace_selection):
        raise IndexError('ID provided does not match the available list.')
    workspace_name, workspace_slug = available_workspaces[workspace_id]['name'], available_workspaces[workspace_id]['slug']

    for repo in Operations.get_repos(env.base_url, env.session, workspace_slug):
        Operations.delete_repo(env.base_url, env.session, workspace_slug, repo['slug'])
        print(f"Delete repo: {repo['slug']} from within the workspace {workspace_name}")

    for project in Operations.get_workspace_projects(env.base_url, env.session, workspace_slug):
        Operations.delete_workspace_project(env.base_url, env.session, workspace_slug, project['key'])
        print(f"Deleting the project '{project['key']}' from the workspace '{workspace_name}'")


if __name__ == '__main__':
    main()
