from resources.connections import Connections


class Operations():
    def get_available_workspaces(base_url, session, paged_start=None):
        while True:
            params = {'page': paged_start}
            url = f'{base_url}/2.0/workspaces'
            r = Connections.get_api(session, url, params)
            r_data = r.json()
            for workspace in r_data['values']:
                yield workspace
            if r_data.get('next') is None:
                return
            else:
                if paged_start is None:
                    paged_start = 1
            paged_start = r_data['page'] + 1

    def get_repos(base_url, session, workspace):
        while True:
            url = f'{base_url}/2.0/repositories/{workspace}'
            r = Connections.get_api(session, url)
            r_data = r.json()
            if r_data.get('values') in [None, []]:  # if None of an empty list
                return
            for repo in r_data.get('values'):
                yield repo

    def delete_repo(base_url, session, workspace, repo):
        url = f'{base_url}/2.0/repositories/{workspace}/{repo}'
        Connections.delete_api(session, url)

    def get_workspace_projects(base_url, session, workspace):
        while True:
            url = f'{base_url}/2.0/workspaces/{workspace}/projects'
            r = Connections.get_api(session, url)
            r_data = r.json()
            if r_data.get('values') in [None, []]:  # if None or an empty list
                return
            for project in r_data.get('values'):
                yield project

    def delete_workspace_project(base_url, session, workspace, project):
        url = f'{base_url}/2.0/workspaces/{workspace}/projects/{project}'
        Connections.delete_api(session, url)
